<script>
import { mapGetters, mapState } from 'vuex'
import ConnectorLogo from '@/components/generic/ConnectorLogo'
import SpeedRunIcon from '@/components/SpeedRunIcon'

export default {
  name: 'Extractors',
  components: {
    ConnectorLogo,
    SpeedRunIcon
  },
  data: () => ({
    speedRunExtractor: 'tap-carbon-intensity'
  }),
  computed: {
    ...mapGetters('plugins', [
      'getIsAddingPlugin',
      'getIsPluginInstalled',
      'getIsInstallingPlugin'
    ]),
    ...mapState('plugins', ['plugins']),
    isLoadingExtractors() {
      return this.plugins.extractors && this.plugins.extractors.length === 0
    }
  },
  created() {
    this.$store.dispatch('plugins/getAllPlugins')
    this.$store.dispatch('plugins/getInstalledPlugins')
  },
  methods: {
    updateExtractorEntitySelection(extractor) {
      this.$router.push({ name: 'extractorEntities', params: { extractor } })
    },
    updateExtractorSettings(extractor) {
      this.$router.push({ name: 'extractorSettings', params: { extractor } })
    }
  }
}
</script>

<template>
  <div>
    <div class="columns">
      <div class="column is-three-fifths is-offset-one-fifth">
        <div class="content has-text-centered">
          <p class="level-item buttons">
            <a class="button is-small is-static is-marginless is-borderless">
              <span>Tell us which extractor(s) to install</span>
            </a>
            <span class="step-spacer">then</span>
            <a class="button is-small is-static is-marginless is-borderless">
              <span>Configure and save their settings</span>
            </a>
          </p>
        </div>
      </div>
    </div>

    <progress
      v-if="isLoadingExtractors"
      class="progress is-small is-info"
    ></progress>

    <div v-else class="tile is-ancestor is-flex is-flex-wrap">
      <div
        v-for="(extractor, index) in plugins.extractors"
        :key="`${extractor}-${index}`"
        class="tile is-parent is-3 is-relative"
      >
        <SpeedRunIcon v-if="extractor === speedRunExtractor" />
        <div class="tile level is-child box">
          <div class="image level-item is-64x64 container">
            <ConnectorLogo
              :connector="extractor"
              :is-grayscale="!getIsPluginInstalled('extractors', extractor)"
            />
          </div>
          <div class="content is-small">
            <p class="has-text-centered">
              {{ extractor }}
            </p>

            <template v-if="getIsPluginInstalled('extractors', extractor)">
              <div class="columns is-variable is-1">
                <div class="column">
                  <a
                    class="button is-interactive-primary is-small is-block"
                    @click="updateExtractorSettings(extractor)"
                    >Configure</a
                  >
                </div>
                <div class="column">
                  <a
                    class="button is-interactive-primary is-outlined is-small is-block"
                    @click="updateExtractorEntitySelection(extractor)"
                    >Select</a
                  >
                </div>
              </div>
            </template>
            <template v-else>
              <a
                :class="{
                  'is-loading':
                    getIsAddingPlugin('extractors', extractor) ||
                    getIsInstallingPlugin('extractors', extractor)
                }"
                class="button is-interactive-primary is-outlined is-block is-small"
                @click="updateExtractorSettings(extractor)"
                >Install</a
              >
            </template>
          </div>
        </div>
      </div>
    </div>
    <progress
      v-if="!plugins.extractors"
      class="progress is-small is-info"
    ></progress>
  </div>
</template>

<style lang="scss"></style>
